/*
 * Erstellt mit SharpDevelop.
 * Programmierer: herbert
 * Datum        : 18.07.2006
 * Uhrzeit      : 18:09
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Diagnostics;
using System.Collections;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace Ausnahmen
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm
	{
		[STAThread]
		public static void Main(string[] args)
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			Application.Run(new MainForm());
		}
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			path	=	"exception.log";
		}
		
		void Button2Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
		
		void Button1Click(object sender, System.EventArgs e)
		{
			Stack	stack	=	new Stack();
			string helppath	=	FehlerMeldung.GetHelpPath();
			try
			{
				try
				{
					uint zahl	=	0xffffffff;	
					try
					{
						checked
						{
							zahl++;
						}
					}
					catch(OverflowException exc)
					{
						exc.HelpLink = helppath + "Hilfe.htm#err1";
						stack.Push(exc);
						throw new BenutzerException("Weiterleitung von Overflow",
						                            string.Format(", uint zahl={0}",zahl) );
					}
				}
				catch(BenutzerException exc)
				{
					exc.HelpLink = helppath + "Hilfe.htm#err2";
					stack.Push(exc);
					throw new ApplicationException("Weiterleitung von BenutzerException", exc);
				}
			}
			catch(ApplicationException exc)
			{
				exc.HelpLink = helppath + "Hilfe.htm#err3";
				stack.Push(exc);
			}
			FileStream fs		= 	new FileStream(path, FileMode.Create, FileAccess.Write);
			BinaryFormatter bf	=	new BinaryFormatter();
			Stack synstack		=	Stack.Synchronized(stack);
			bf.Serialize(fs,synstack);
			fs.Close();
			
		}
		/// <summary>
		/// Protokoll ansehen
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		void Button3Click(object sender, System.EventArgs e)
		{
			BinaryFormatter bf	= new BinaryFormatter();
			if( File.Exists(path))
			{
			 	FileStream fs	= new FileStream(	path, 
			                                 		FileMode.Open,
			                                 		FileAccess.Read);
			
				Stack stack			= (Stack)bf.Deserialize(fs);
				FehlerMeldung fm 	= new FehlerMeldung(stack);
				fm.fenster.Show();
				fs.Close();
			}
			else
			{
				MessageBox.Show("Sie mssen zuerst den Button Ausnahme auslsen klicken",
				                "Achtung",MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
			}
		}
	}
	[Serializable]
	public class BenutzerException : ApplicationException,ISerializable
	{
		private string detail;
		public string Detail
		{
			get 
			{
				return detail;
			}
		}
		public BenutzerException(){}
		public BenutzerException(string msg):base(msg){}
		public BenutzerException(string msg, string detail):base(msg){this.detail=detail;}
		public BenutzerException(string msg, Exception exc):base(msg,exc){}
		protected BenutzerException(SerializationInfo info, 
		                            StreamingContext context):base(info,context)
		{
			detail	=	info.GetString("detail");
		}
		public override void GetObjectData(	SerializationInfo info,
        									StreamingContext context)
   		{
      		base.GetObjectData(info, context);
      		info.AddValue("detail", detail);      
   		}
		public override string Message
  		{
	      	get
      		{
            	return base.Message + " " + detail;
      		}
		}
   	}
	public class FehlerMeldung 
	{
		
		public  Form fenster;
		private Button bende;
		private RichTextBox tbox;
		private LinkLabel link;
		public FehlerMeldung(Stack stack)
		{
			int x			=	500;
			int y			=	300;
			int rand		=	20;
			int xbende		=	75;
			int ybende		=	23;
			fenster			= 	new Form();
			bende			= 	new Button();
			tbox			=	new RichTextBox();
			link			=	new LinkLabel();
			fenster.FormBorderStyle	= FormBorderStyle.Fixed3D;
			fenster.ClientSize	= new Size(x, y);
			fenster.Icon	= 	new Icon("logo.ico");
			fenster.Text	= 	"Fehler";
			fenster.StartPosition	= FormStartPosition.CenterScreen;
			tbox.Size		=	new Size(x-2*rand,y-3*rand-ybende);
			tbox.Location	=	new Point(rand, rand);
			tbox.Multiline	=	true;
			tbox.WordWrap	=	false;
			tbox.ReadOnly	=	true;
			tbox.DetectUrls	=	true;
			tbox.BackColor	=	Color.WhiteSmoke;
			bende.Size		=	new Size(xbende, ybende);
			bende.Text		= 	"&Beenden";
			bende.Location	= 	new Point(x-rand-xbende,y-rand-ybende);
			link.Location	=	new Point( rand, y-rand-ybende);
			link.Size		=	new Size( x-3*rand-xbende,ybende);
			link.LinkColor 	= System.Drawing.Color.Navy;
			link.DisabledLinkColor 	= System.Drawing.Color.Silver;
        	link.VisitedLinkColor 	= System.Drawing.Color.Blue;
      		link.LinkBehavior 		= System.Windows.Forms.LinkBehavior.AlwaysUnderline;
			int anz			= 	stack.Count;
			int lines		=	7;
			string[] str	=	new string[anz*lines];
			for ( int i=0;i < anz;i++)
			{
				Exception exc	=	null;
				exc	=	(Exception)stack.Pop();
				str[i*lines]	=	string.Format("\n{0}.Ebene",anz-i);
				str[i*lines+1]	=	"----------------------------------";
				str[i*lines+2]	=	"Beschreibung:\t" 	+ exc.Message	;
				str[i*lines+3] 	=	"Quelle:\t\t"	+ exc.Source + ": " + exc.GetType().ToString();
				str[i*lines+4] 	=	"TargetSite:\t";
				if(exc.TargetSite != null)
					str[i*lines+4] 	+= exc.TargetSite.Name;
				else
					str[i*lines+4]	+=	"Die auslsende Methode konnte nicht abgerufen werden.";
				str[i*lines+5] 		+=	"Stacktrace:\t" + exc.StackTrace	;
				str[i*lines+6]		=	"HelpLink:\t\t";
				if(exc.HelpLink !=	null)
				{
					link.Text		+=	string.Format("Hilfe zu {0}.   ",i+1);
					link.Links.Add(link.Text.Length-15,11,exc.HelpLink);
					str[i*lines+6]	+=	exc.HelpLink;
				}
			}
			tbox.Lines			=	str;
			bende.Click			+= 	new EventHandler(EndeClick);
			link.LinkClicked	+= 	new LinkLabelLinkClickedEventHandler(Link4Click1);
			tbox.LinkClicked	+= 	new LinkClickedEventHandler(Link4Click2);
			fenster.Controls.Add(bende);
			fenster.Controls.Add(tbox);
			fenster.Controls.Add(link);
		}
		private void EndeClick(object sender, System.EventArgs e)
		{
				fenster.Close();
		}
		private void Link4Click1(object sender, LinkLabelLinkClickedEventArgs e)
		{
			Trace.WriteLine("Label: " + e.Link.LinkData.ToString());
			Process.Start(e.Link.LinkData.ToString());
		}
		private void Link4Click2(object sender, LinkClickedEventArgs e)
		{
			Trace.WriteLine("TextBox: " + e.LinkText);
			Process.Start(e.LinkText);
		}
		public static string GetHelpPath()
		{
			string path		=	System.Environment.CurrentDirectory;
			string[] parts	=	path.Split(new Char[]{'\\'});
			path			=	"file:///";
			foreach( string str in parts)
			{
				path	+=	str + "/";
			}
			return path;
		}
	}
}
